//ATmega8
//4,000000 MHz
// 100%!!!!
// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


/*
  CodeVisionAVR C Compiler
  (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

  Prototype for SPI access function */
  

#pragma used+
#pragma used+
unsigned char spi(unsigned char data);
#pragma used-

#pragma library spi.lib

//  Mega8 port B pinout for LCD.


//        
unsigned char   lcd_buf[14];		//     LCD
unsigned char   LcdCache [816];	//   (504  816 )
unsigned int    LcdCacheIdx;     //Cache index
unsigned int    adc_data;        //  
unsigned int    ind;             //   . .
unsigned int    Vtis,Vsot,Vdes,Ved;


const char table[455]=     
{
0x00, 0x00, 0x00, 0x00, 0x00,//0 20 space
0x00, 0x00, 0x5F, 0x00, 0x00,//1 21 !
0x00, 0x07, 0x00, 0x07, 0x00,//2 22 "
0x14, 0x7F, 0x14, 0x7F, 0x14,//3 23 #
0x24, 0x2A, 0x7F, 0x2A, 0x12,//4 24 $
0x23, 0x13, 0x08, 0x64, 0x62,//5 25 %
0x36, 0x49, 0x55, 0x22, 0x50,//6 26 &
0x00, 0x05, 0x03, 0x00, 0x00,//7 27 '
0x00, 0x1C, 0x22, 0x41, 0x00,//8 28 (
0x00, 0x41, 0x22, 0x1C, 0x00,//9 29 )
0x14, 0x08, 0x3E, 0x08, 0x14,//10 2a *
0x08, 0x08, 0x3E, 0x08, 0x08,//11 2b +
0x00, 0x50, 0x30, 0x00, 0x00,//12 2c ,
0x08, 0x08, 0x08, 0x08, 0x08,//13 2d -
0x00, 0x60, 0x60, 0x00, 0x00,//14 2e .
0x20, 0x10, 0x08, 0x04, 0x02,//15 2f /
0x3E, 0x51, 0x49, 0x45, 0x3E,//16 30 0
0x00, 0x42, 0x7F, 0x40, 0x00,//17 31 1
0x42, 0x61, 0x51, 0x49, 0x46,//18 32 2
0x21, 0x41, 0x45, 0x4B, 0x31,//19 33 3
0x18, 0x14, 0x12, 0x7F, 0x10,//20 34 4
0x27, 0x45, 0x45, 0x45, 0x39,//21 35 5
0x3C, 0x4A, 0x49, 0x49, 0x30,//22 36 6
0x01, 0x71, 0x09, 0x05, 0x03,//23 37 7
0x36, 0x49, 0x49, 0x49, 0x36,//24 38 8
0x06, 0x49, 0x49, 0x29, 0x1E,//25 39 9
0x00, 0x36, 0x36, 0x00, 0x00,//26 3a :
0x00, 0x56, 0x36, 0x00, 0x00,//27 3b ;
0x08, 0x14, 0x22, 0x41, 0x00,//28 3c <
0x14, 0x14, 0x14, 0x14, 0x14,//29 3d =
0x00, 0x41, 0x22, 0x14, 0x08,//30 3e >
0x02, 0x01, 0x51, 0x09, 0x06,//31 3f ?
0x32, 0x49, 0x79, 0x41, 0x3E,//32 40 @
0x7E, 0x11, 0x11, 0x11, 0x7E,//33 41 A
0x7F, 0x49, 0x49, 0x49, 0x36,//34 42 B
0x3E, 0x41, 0x41, 0x41, 0x22,//35 43 C
0x7F, 0x41, 0x41, 0x22, 0x1C,//36 44 D
0x7F, 0x49, 0x49, 0x49, 0x41,//37 45 E
0x7F, 0x09, 0x09, 0x09, 0x01,//38 46 F
0x3E, 0x41, 0x49, 0x49, 0x7A,//39 47 G
0x7F, 0x08, 0x08, 0x08, 0x7F,//40 48 H
0x00, 0x41, 0x7F, 0x41, 0x00,//41 49 I
0x20, 0x40, 0x41, 0x3F, 0x01,//42 4a J
0x7F, 0x08, 0x14, 0x22, 0x41,//43 4b K
0x7F, 0x40, 0x40, 0x40, 0x40,//44 4c L
0x7F, 0x02, 0x0C, 0x02, 0x7F,//45 4d M
0x7F, 0x04, 0x08, 0x10, 0x7F,//46 4e N
0x3E, 0x41, 0x41, 0x41, 0x3E,//47 4f O
0x7F, 0x09, 0x09, 0x09, 0x06,//48 50 P
0x3E, 0x41, 0x51, 0x21, 0x5E,//49 51 Q
0x7F, 0x09, 0x19, 0x29, 0x46,//50 52 R
0x46, 0x49, 0x49, 0x49, 0x31,//51 53 S
0x01, 0x01, 0x7F, 0x01, 0x01,//52 54 T
0x3F, 0x40, 0x40, 0x40, 0x3F,//53 55 U
0x1F, 0x20, 0x40, 0x20, 0x1F,//54 56 V
0x3F, 0x40, 0x38, 0x40, 0x3F,//55 57 W
0x63, 0x14, 0x08, 0x14, 0x63,//56 58 X
0x07, 0x08, 0x70, 0x08, 0x07,//57 59 Y
0x61, 0x51, 0x49, 0x45, 0x43,//58 5a Z
0x00, 0x7F, 0x41, 0x41, 0x00,//59 5b [
0x02, 0x04, 0x08, 0x10, 0x20,//60 5c Yen Currency Sign
0x00, 0x41, 0x41, 0x7F, 0x00,//61 5d ]
0x04, 0x02, 0x01, 0x02, 0x04,//62 5e ^
0x40, 0x40, 0x40, 0x40, 0x40,//63 5f _
0x00, 0x01, 0x02, 0x04, 0x00,//64 60 `
0x20, 0x54, 0x54, 0x54, 0x78,//65 61 a
0x7F, 0x48, 0x44, 0x44, 0x38,//66 62 b
0x38, 0x44, 0x44, 0x44, 0x20,//67 63 c
0x38, 0x44, 0x44, 0x48, 0x7F,//68 64 d
0x38, 0x54, 0x54, 0x54, 0x18,//69 65 e
0x08, 0x7E, 0x09, 0x01, 0x02,//70 66 f
0x0C, 0x52, 0x52, 0x52, 0x3E,//71 67 g
0x7F, 0x08, 0x04, 0x04, 0x78,//72 68 h
0x00, 0x44, 0x7D, 0x40, 0x00,//73 69 i
0x20, 0x40, 0x44, 0x3D, 0x00,//74 6a j
0x7F, 0x10, 0x28, 0x44, 0x00,//75 6b k
0x00, 0x41, 0x7F, 0x40, 0x00,//76 6c l
0x7C, 0x04, 0x18, 0x04, 0x78,//77 6d m
0x7C, 0x08, 0x04, 0x04, 0x78,//78 6e n
0x38, 0x44, 0x44, 0x44, 0x38,//79 6f o
0x7C, 0x14, 0x14, 0x14, 0x08,//80 70 p
0x08, 0x14, 0x14, 0x18, 0x7C,//81 71 q
0x7C, 0x08, 0x04, 0x04, 0x08,//82 72 r
0x48, 0x54, 0x54, 0x54, 0x20,//83 73 s
0x04, 0x3F, 0x44, 0x40, 0x20,//84 74 t 
0x3C, 0x40, 0x40, 0x20, 0x7C,//85 75 u 
0x1C, 0x20, 0x40, 0x20, 0x1C,//86 76 v 
0x3C, 0x40, 0x30, 0x40, 0x3C,//87 77 w 
0x44, 0x28, 0x10, 0x28, 0x44,//88 78 x 
0x0C, 0x50, 0x50, 0x50, 0x3C,//89 79 y 
0x44, 0x64, 0x54, 0x4C, 0x44};//90 7a z 

void hex_to_dec(void)         //    hex  dec 
{
  Vtis=0;                     //  
  while (ind>=1000)           // 
  {
  ind-=1000;
  Vtis++;
  }
  
  Vsot=0;                     //  
  while (ind>=100)            // 
  {
  ind-=100;
  Vsot++;
  }
  
  Vdes=0;                     //  
  while (ind>=10)             // 
  {
  ind-=10;
  Vdes++;
  }
  
  Ved=0;                      //  
  while (ind>=1)              // 
  {
  ind-=1;
  Ved++;
  };
}

void LcdSend (unsigned char data, unsigned char cmd) //Sends data to display controller
{
  PORTB.2   = 0;                          //Enable display controller (active low)
    
  if (cmd)                                 // , 
     PORTB.0   = 1;	                       //LCD_DC_PIN = 1
  
  else PORTB.0   = 0;                   
       spi (data);                         //Send data to display controller
}

void LcdUpdate (void)                      //Copies the LCD cache into the device RAM
{
  int i;
  	char j;
	  
  LcdSend( 0x80, 0 );                            
  LcdSend( 0x40, 0 );
  
  		for (j = 102; j>0; j--) LcdSend(0, 1);
	
  for (i = 0; i < 504; i++)		//  (504   816 )
  {
    LcdSend(LcdCache[i], 1);
    
     if (++j == 84) 
    {
	for (j = (102-84); j>0; j--) LcdSend(0, 1);
	j=0;
    }
    }
}

void LcdClear (void)    //Clears the display
  {
    int i;
                                                //(504   816 )
	  for (i = 0; i < 816; i++) LcdCache[i] = 0;	//   0
  }

void LcdInit ( void )	// SPI  
  {
    PORTB.4   = 1;   //  /
    delay_ms(50);      //SPI Control Register  SPCR
    SPCR = 0x50;       //Enable SPI: No interrupt, MSBit first, Master mode, CPOL->0, CPHA->0, Clk/4
    PORTB.4   = 0;   // 
    delay_ms(500);     //
    PORTB.4   = 1;   //
                            
    PORTB.2   = 1;    //Disable LCD controller

    LcdSend( 0x21, 0 ); 			//LCD Extended Commands
    LcdSend( 0x06, 0 ); 			//Set Temp coefficent
    LcdSend( 0x13, 0 ); 			//LCD bias mode 1:48
    LcdSend( 0xC8, 0 ); 			//Set LCD Vop (Contrast)0xC5  0xC8!!! -   0xAA - .
    LcdSend (0x20, 0 );       //Horizontal addressing mode.  
	  LcdSend (0x0C, 0 );       //normal mode.                
    //LcdClear();
  };                

//Sets cursor location to xy location. Range: 1,1 .. 14,6
void LcdGotoXYFont (unsigned char x, unsigned char y)   
{
  if (x <= 14 && y<= 6)                              //6  48/8 
  LcdCacheIdx = ((int)(y)-1)*84 + ((int)(x)-1)*6;    //
}

//Displays a bold character at current cursor location and increment cursor location
void LcdChrBold (int ch)	
{
  unsigned char i;
  unsigned int a = 0, b = 0, c = 0;   //unsigned char a = 0, b = 0, c = 0;

  for ( i = 0; i < 5; i++ )     //i++    for ( i = 0; i < 5; i++ ) 
{
  c = table[((ch*5)-160+i)];		  //      c = table[((ch*5)-160+i)];

  b =  (c & 0x01) * 3;            //3  ""    
  b |= (c & 0x02) * 6;            //6     
  b |= (c & 0x04) * 12;           //12
  b |= (c & 0x08) * 24;           //24

  c >>= 4;                        //c >>= 4;
  
  a =  (c & 0x01) * 3;            //3     
  a |= (c & 0x02) * 6;            //6
  a |= (c & 0x04) * 12;           //12
  a |= (c & 0x08) * 24;           //24

  LcdCache[LcdCacheIdx]=b;	      //    
  LcdCache[LcdCacheIdx+1]=b;      //    
  LcdCache[LcdCacheIdx+84]=a;    // 84  102   !!!
  LcdCache[LcdCacheIdx+85]=a;    // 85  103
  LcdCacheIdx = LcdCacheIdx+2;    //+2
  }

  LcdCache[LcdCacheIdx++] = 0x00;	  //  
  LcdCache[LcdCacheIdx++] = 0x00;   // 
 	}                                     

//Displays a string at current cursor location
void LcdStringBold (unsigned char x, unsigned char y)	
{
unsigned char i;

LcdGotoXYFont (x, y);
for ( i = 0; i < 14-x; i++ )     //for ( i = 0; i < 14-x; i++ )

if (lcd_buf[i]) 
LcdChrBold (lcd_buf[i]);
}

// ADC interrupt service routine
interrupt [15] void adc_isr(void) //   
{
adc_data=ADCW; //    ads_data
ind=1000.0*adc_data*5.0/1024;
hex_to_dec();

  LcdClear(); //     . .  !!!
      sprintf (lcd_buf,"U=%u,%u%u",Vtis,Vsot,Vdes);
		  LcdStringBold(2,2);               //  2 . y=2  
		  
		  LcdUpdate();

		  delay_ms(50);	
};

void main(void)
{
 
 DDRB=0b00111101;       //PORTB.0, PORTB.2 - PORTB.5  .
PORTB=0b00101001;       //  1 .

 DDRC=0b1111110;        //PC.0  .  .
PORTC=0b0000000;

 DDRD=0b11111111;
PORTD=0b00000000;

// Analog Comparator: Off
ACSR=0x80;
SFIOR=0x00;

//  
//   101=k=32 4000/32=125    

ADCSRA=0b10001101;   //7-  3-. 101   32

ADMUX=0b00000000;    //0-  -PC0,  

//  
ADCSRA|=0x60;        //ADCSRA|=0x60;=0b1000000
    
LcdInit();
#asm("sei") 
  while (1){};  
}
